#!/usr/bin/perl -w

#    CGINews - Remotely add news-entries to a site
#    Copyright (C) 1999-2002  Markus Triska
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111 USA
#
#    Contact me at triska@gmx.at

use CGI;
use strict;

# CONFIG SECTION (please adjust values in cginews.conf!)
##########################################
my $webadmin = 'not@specified';
my $maxmainnews = 20;
my $linkbefore_main = "<a href=\"../sections/##section##/##article##\">";
my $linkafter_main = '</a>';
my $linktoarticle_main = "<br>Click <a href=\"../sections/##section##/##article##\">here</a> for more.<br>";
my $linkbefore_section = "<a href=\"##article##\">";
my $linkafter_section = '</a>';
my $linktoarticle_section = "<br>Click <a href=\"##article##\">here</a> for more.<br>";
my $linkbefore_preview = "<a href=\"##sectionbase####section##/##article##\">";
my $linkafter_preview = "</a>";
my $linktoarticle_preview = "<br>Click <a href=\"##sectionbase####section##/##article##\">here</a> for more.<br>";
my $nextitemstext = "Next ##X## items...";
my $nextitemtext = "Next item...";
my $dateseparator = "<center><table border=0 cellspacing=0 cellpadding=0><tr><td class=\"datum\" colspan=3>##weekday##, ##month##.##day##.##year##</td><tr></table></center><br>";
my $sectiondates = 0;
my $fullsections = 0;
my $deleteforgood = 0;
my @TheSections = ();
##########################################
# CONFIG ENDS


my $cgi = new CGI;

my @ShortWeekDays = ('Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun');

# First, some global variables:
my %FullWeekDay = (
	Mon => 'Monday', Tue => 'Tuesday', Wed => 'Wednesday',
	Thu => 'Thursday', Fri => 'Friday', Sat => 'Saturday', Sun => 'Sunday'
);

my %NumMonth = (
	Jan => "01", Feb => "02", Mar => "03", Apr => "04", May => "05",
	Jun => "06", Jul => "07", Aug => "08", Sep => "09", Oct => "10",
	Nov => "11", Dec => "12"
);


# User data (name, syntax, email) of current user
my %UserData = ();
# Data of current edited NEWS that has to be posted or viewed in preview
my %NewsData = ();
# Interesting dates and times, each formatted a bit differently
my %DateTime = ();
# Access levels of each user
my %AccessLevel = ();

my $ppnews = '../news/';
my $ppuser = '../users/';
my $pphtml = '../html/';
my $sectionbase="../";

sub filterUserInput
{
	my $string = shift;

	# This code was contributed by b0iler@hotmail.com . Many thanks!
	$string =~ s/([\&;\\\`'\|\"*\?\~\^\(\)\[\]\{\}\$\n\r])/\\$1/g; #meta characters
	$string =~ s/\0//g; # null byte
	$string =~ s/\.\.//g; # then ..

	return $string;
}

sub substSpecialChars
{
	my $string = shift;

	$string =~ s//\&auml\;/gi; $string =~ s//\&Auml\;/gi;
	$string =~ s//\&ouml\;/gi; $string =~ s//\&Ouml\;/gi;
	$string =~ s//\&uuml\;/gi; $string =~ s//\&Uuml\;/gi;

	$string =~ s/\n/\<BR\>/gi;
	$string =~ s//\&szlig\;/g;
	# Please add more special characters

	return $string;
}

sub SubstRefVars
{
	my $line = shift;
	my $dest = shift;

	my $referredvar = '';
	while ($line =~ /.*?\#\#.*?\#\#.*/) {
		(my $refvar = $line) =~ s/.*?\#\#(.*?)\#\#.*/$1/;
		chomp $refvar;
		if ( exists $UserData{"$refvar"} ) {
			$referredvar = $UserData{"$refvar"};
		} elsif ( exists $NewsData{"$refvar"} ) {
			$referredvar = $NewsData{"$refvar"};
		} elsif ( exists $DateTime{"$refvar"} ) {
			$referredvar = $DateTime{"$refvar"};
		} elsif ( $refvar eq 'linkbefore') {
			if ($dest eq 'main') {
				$referredvar = $linkbefore_main;
			} elsif ($dest eq 'sec') {
				$referredvar = $linkbefore_section;
			} elsif ($dest eq 'pre') {
				$referredvar = $linkbefore_preview;
			} else  {
				$referredvar = "Error - no destination";
			}
		} elsif ( $refvar eq 'linkafter') {
			if ($dest eq 'main') {
				$referredvar = $linkafter_main;
			} elsif ($dest eq 'sec') {
				$referredvar = $linkafter_section;
			} elsif ($dest eq 'pre') {
				$referredvar = $linkafter_preview;
			} else {
				$referredvar = "Error - no destination";
			}
		} elsif ($refvar eq 'sectionboxes') {
			foreach my $section (@TheSections) {
				$section =~ tr/A-Z/a-z/;
				$referredvar .= "<option value=\"$section\"";
				if (exists $NewsData{'section'}) {
					if ($section eq $NewsData{'section'}) {
						$referredvar .= " selected";
					}
				}
				$referredvar .= ">$section";
			}
		} else {
			$referredvar = "\%\%$refvar\%\%";
#			$referredvar = "Warning...could NOT substitute $refvar";
		}
		$referredvar = substSpecialChars($referredvar);

		$line =~ s/##.*?##/$referredvar/;

	}
	$line =~ s/\%\%/##/g;
	return $line;
}


# Print a HTML-file with full substitution of variables.
sub OutputHTMLFile
{
	my $filename = shift;

	# The "internal" HTML-files (news-upload etc.) are now (since 1.03)
	# located in "cginews/html/internal/" - print a message if they are
	# not there

	if (!-e "$pphtml" . "internal/$filename") {
		print "<html><head><title>$filename</title></head><body><br>The file <font color=\"#009900\">$filename</font> does NOT exist in $pphtml" . "internal/. <br>If you were using a version of CGINews prior to 1.03, see the file UPGRADE for details.";
		exit;
	}

	open IN, "<$pphtml" . "internal/$filename";
	while (<IN>) {
		print SubstRefVars($_);
	}
	close IN;
}


# LOG an action
sub Log
{
	my $TodayDate = localtime;
	my $logmessage = shift;
	my $CurrentUser = $UserData{'userid'};
	open USERLOG, ">>$ppuser$CurrentUser/$CurrentUser.log";
#	open MAINLOG, ">>prot.log";
	print USERLOG "$TodayDate: $UserData{'userid'} $logmessage";
#	print MAINLOG "$TodayDate: $UserData{'userid'} $logmessage";
	close USERLOG;
#	close MAINLOG;
}


# EncDec just makes sure that passwords are not stored in plain text.
sub EncDec
{
	my @args = split //, shift();
	my $retval = '';
	for (my $stringpos = 0; $stringpos <= $#args; $stringpos++) {
		$retval .= chr(ord($args[$stringpos]) ^ 0x12);
	}
	return $retval;
}


sub CheckPassword
{
	my $UserPassword = '';
	my $CurrentUser = $UserData{'userid'};
	my $CurrentPassword = $cgi->param('password') || '';
	$CurrentPassword = filterUserInput($CurrentPassword);

	my $PwOK = 0;

	# Account not created - failure.
	if (!-d "$ppuser$CurrentUser") { return 0; }

	if (!-e "$ppuser$CurrentUser/$CurrentUser.pwl") {
		# First login. Password must equal name.
		if ($CurrentPassword ne $CurrentUser) {
			$PwOK = 0; 
		} else { 
			$PwOK = 1; 
		}
	} else {
		open PW, "<$ppuser$CurrentUser/$CurrentUser.pwl";
		$UserPassword = <PW>;
		$UserPassword = EncDec($UserPassword);
		if ($CurrentPassword ne $UserPassword) {
			$PwOK = 0;
		} else {
			$PwOK = 1;
		}
		close PW;
	}

	$UserData{'password'} = $CurrentPassword;
	return $PwOK;
}

# Get info (currently only E-Mail/Nickname) for a given user
# fill hash UserData
sub GetUserInfo
{
	my $author = pop;
	my $Syntax = '';
	my $EMail = '';

	if (-e "$ppuser$author/$author.syn") {
		open IN, "<$ppuser$author/$author.syn";
		$Syntax = <IN>;
		chomp($Syntax);
		close IN;
	} else {
		$Syntax = $author;
	}
	if (-e "$ppuser$author/$author.eml") {
		open IN, "<$ppuser$author/$author.eml";
		$EMail = <IN>;
		chomp($EMail);
		close IN;
	} else {
		$EMail = $webadmin;
	}
	$UserData{'syntax'} = $Syntax;
	$UserData{'nickname'} = $Syntax;
	$UserData{'email'} = $EMail;
}



# Change user password
sub ChangeUserPassword
{
	my $NewPw = $cgi->param('newpassword');
	my $RetypePw = $cgi->param('retype');
	my $CurrentUser = $UserData{'userid'};

	if ($NewPw eq $RetypePw) {
		open PW, ">$ppuser$CurrentUser/$CurrentUser.pwl";
		$NewPw = EncDec($NewPw);
		print PW $NewPw;
		close PW;
		OutputHTMLFile('pwok.html');
		Log("changed password.\n");
		$UserData{'pw'} = $NewPw;
	} else {
		print "Error.";
		OutputHTMLFile('pwfailed.html');
		Log("tried to change password.\n");
	}
}


# GetNewsData - used by DisplayPreview as well as SaveMessage
# Read in information of the current edited news - fill NewsData
sub GetNewsData
{
	my $Section = $cgi->param('section') || 'none';
	if (($Section eq '') || ($Section =~ /\s+/)) { $Section = 'none'; }
	$NewsData{'section'} = filterUserInput($Section);

	my $Headline = ($cgi->param('headline')) || '';
	my $Text = ($cgi->param('text')) || '';

	my $article = $cgi->param('article') || 'none';
	chomp $article;
	if (($article eq '') || ($article =~ /\s+/) ) { $article = 'none';}
	$article =~ s/.*\/(.*)/$1/;
	$article =~ s/.*\\(.*)/$1/;

	$NewsData{'file'} = $article;
	$NewsData{'article'} = $article;

	$NewsData{'headline'} = $Headline;
	$NewsData{'text'} = $Text;
}

# Fill DateTime-hash from filename of a news
sub ConvertDateTime
{
	my $date = shift;
	my $year = substr $date, 0, 4;
	my $month = substr $date, 4, 2;
	my $day = substr $date, 6, 2;
	my $hour = substr $date, 8, 2;
	my $minute = substr $date, 10, 2;
	my $second = substr $date, 12, 2;

	my $Date = "$day.$month.$year";
	my $Time = "$hour:$minute:$second";

	$DateTime{'date'} = $Date;                  # 12.12.1982
	$DateTime{'day'} = substr $Date, 0, 2;
	$DateTime{'month'} = substr $Date, 3, 2;
	$DateTime{'year'} = substr $Date, 6, 4;
	$DateTime{'time'} = $Time;
	$DateTime{'hour'} = substr $Time, 0, 2;     # 16:03:22
	$DateTime{'minute'} = substr $Time, 3, 2;
	$DateTime{'second'} = substr $Time, 6, 2;
}

# WriteHeader - write HTML-header for newsfile of each section

sub WriteHeaders
{
	my $section = '';
	foreach $section (@TheSections) {
		if (-d "$sectionbase$section") {
			my $hdrfile = "$pphtml" . "news.hdr";
			if (-e "$sectionbase$section/news.hdr") {
				$hdrfile = "$sectionbase$section/news.hdr";
			} elsif (-e "$sectionbase$section/$section.hdr") {
				$hdrfile = "$sectionbase$section/$section.hdr";
			} elsif (-e "$pphtml$section.hdr") {
				$hdrfile = "$pphtml$section.hdr";
			} elsif (-e "$pphtml/sections.hdr") {
				$hdrfile = "$pphtml" . "sections.hdr";
			}
			open NEWSHDR, "<$hdrfile";
			open SECNEWS, ">$sectionbase$section/$section.html";
			while (<NEWSHDR>) {
				print SECNEWS;
			}
			close NEWSHDR;
			close SECNEWS;
		}
	}
	open FULLNEWS, ">$ppnews" . "news.html";
	open NEWSHDR, "<$pphtml" . "news.hdr";
	while (<NEWSHDR>) {
		print FULLNEWS;
	}
	close NEWSHDR;
	close FULLNEWS;
}


sub WriteFooters
{
	my $section = '';
	foreach $section (@TheSections) {
		if (-d "$sectionbase$section") {

			my $sectionendfile = '__notspecified';

			if (-e "$pphtml$section.end") {
				$sectionendfile = "$pphtml$section.end";
			} elsif (-e "$pphtml/sections.end") {
				$sectionendfile = "$pphtml" . "sections.end";
			}

			if (-e $sectionendfile) {
				open SECTIONEND, "<$sectionendfile";
				open SECNEWS, ">>$sectionbase$section/$section.html";
				while (<SECTIONEND>) {
					print SECNEWS;
				}
				close SECNEWS;
				close SECTIONEND;
			} else {
				open SECNEWS, ">>$sectionbase$section/$section.html";
				print SECNEWS "</body></html>";
				close SECNEWS;
			}
		}
	}
}

sub FileToScalar
{
	my $file = pop;
	my $scalar = '';
	open FILE, "<$file";
	while (<FILE>) {
		chomp $scalar;
		$scalar .= $_;
	}
	close FILE;
	return $scalar;
}


# convert ##here## to ##linkbefore##here##linkafter##
sub InsertLinkToArticle
{
	my $text = pop;
	if ($text =~ /##.*##/) {
		(my $linktext = $text) =~ s/(.|\n)*?##(.*?)##(.|\n)*/$2/m;
		chomp $linktext;

		my $link = "##linkbefore##" . $linktext .  "##linkafter##";
		$text =~ s/##.*##/$link/;
		$NewsData{'hasownlink'} = 1;
	}
	return $text;
}



sub WriteNewsFiles
{
	my @AllNews = ();
	my $nummainnews = 0;
	my $mainnewswritten = 0;
	my $currentmainnewsfile = 0;
	my %SectionTemplate = ();

	my $section_template = FileToScalar("$pphtml" . 'sections.pre');
	foreach my $section (@TheSections) {
		if (-e "$pphtml$section.pre") {
			$SectionTemplate{"$section"} = FileToScalar("$pphtml$section.pre");
		} else {
			$SectionTemplate{"$section"} = $section_template;
		}
	}

	if (-e "$ppnews" . "news.db") {
		open DB, "<$ppnews" . "news.db";
		@AllNews = <DB>;
		close DB;
	}

	my $entry_template = FileToScalar("$pphtml" . 'news.pre');

	# Legacy code - we had no "news.end" prior to 1.02
	my $mainnewsend = "</body></html>";
	if (-e "$pphtml" . 'news.end') {
		$mainnewsend = '';
		open MAINNEWSEND, "$pphtml" . 'news.end';
		while (<MAINNEWSEND>) {
			$mainnewsend .= $_;
		}
		close MAINNEWSEND;
	}


	my $mainnewsleft = $#AllNews + 1;
	foreach my $deletedentry (glob ("$ppnews" . "*del")) {
		$mainnewsleft--;
	}

	# First, create header for all section-files
	WriteHeaders();

	my $counter = $#AllNews;
	my %lastdate = ();
	$lastdate{'none'} = "0";
	my $newdate = '';
	open FULLNEWS, ">>$ppnews" . "news.html";

	do {
		( my $key,  my $weekday, my $author, my $section, my $writemainnews, my $File) = split(/ /, $AllNews[$counter]);
		$author =~ tr/A-Z/a-z/;
		# Check whether file is deleted ($key.del) exists

		if (-e "$ppnews$key" . ".del") {
			goto ISDELETED;
		}

		if (-e "$ppnews$key.wmn") {
			# Write main news?
			open WMN, "<$ppnews$key.wmn";
			$writemainnews = <WMN>;
			close WMN;
		}

		# We now have EVERY news in main...
		$writemainnews = 1;

		if (-e "$ppnews$key.sec") {
			# Different section than in news.db?
			open SECTION, "<$ppnews$key.sec";
			$section = <SECTION>;
			chomp $section;
			close SECTION;
		}


#		print "Reading date: $key\n";
		ConvertDateTime($key);
		$newdate = substr $key, 0, 8;

		my $Weekday = $FullWeekDay{ (substr $weekday, 0, 3)};
		$DateTime{'weekday'} = $Weekday;
		my $datetext = SubstRefVars($dateseparator);
		foreach my $asection (@TheSections) {
			$lastdate{$asection} = '0';
		}

		if (($section ne 'none') && ($lastdate{$section} ne $newdate)) {
			if ($sectiondates) {
				open SECNEWS, ">>$sectionbase$section/$section.html";
				print SECNEWS $datetext;
				close SECNEWS;
			}
			$lastdate{$section} = $newdate;
		}
		if (($writemainnews) && ($lastdate{'none'} ne $newdate)) {
			print FULLNEWS $datetext;
			$lastdate{'none'} = $newdate;
		}

		if (-e "$ppnews$key.fil") {
			open ARTICLE, "<$ppnews$key.fil";
			$NewsData{'article'} = <ARTICLE>;
			close ARTICLE;
		} else {
			$NewsData{'article'} = $File;
		}

		chomp $NewsData{'article'};

		# These substitutions are now placed in GetNewsData, where
		# they belong. Older versions of CGINews, however, may have
		# saved some filenames incorrectly (= with directory name)
		$NewsData{'article'} =~ s/.*\/(.*)/$1/;
		$NewsData{'article'} =~ s/.*\\(.*)/$1/;

		$NewsData{'file'} = $NewsData{'article'};

		$NewsData{'section'} = $section;

		open HDL, "<$ppnews" . "$key.hdl";
		$NewsData{'headline'} = <HDL>;
		close HDL;

		$NewsData{'hasownlink'} = 0;
		$NewsData{'text'} = '';
		open TEXT, "<$ppnews" . "$key.msg";
		while (<TEXT>) {
			$_ = InsertLinkToArticle($_);
			$NewsData{'text'} .= $_;
		}
		close TEXT;

		GetUserInfo($author);

		my $newsdata_text = $NewsData{'text'};

		# Append entry to section...
		if ($section ne 'none') {
			# ...if file attached or configured that way
			if (($NewsData{'article'} !~ /^none$/) || $fullsections) {
				open SECNEWS, ">>$sectionbase$section/$section.html";
				if (($NewsData{'article'} !~ /^none$/) && (!$NewsData{'hasownlink'})) {
					$NewsData{'text'} .= $linktoarticle_section;
				}
				my $secnews = SubstRefVars($SectionTemplate{"$section"}, 'sec');
				print SECNEWS "$secnews";
				close SECNEWS;
			}
		}
		$NewsData{'text'} = $newsdata_text;
		if ($writemainnews) {
 			if (($NewsData{'article'} !~ /^none$/) && (!$NewsData{'hasownlink'})) {
				$NewsData{'text'} .= $linktoarticle_main;
			}
			my $mainnews = SubstRefVars($entry_template, 'main');
			print FULLNEWS "$mainnews";

			$mainnewsleft -= 1;
			$mainnewswritten += 1;
			if ( ($maxmainnews > 0) && ($mainnewswritten >= $maxmainnews) && ($mainnewsleft > 0)) {

				$currentmainnewsfile += 1;
				my $nextnewsfile = "news" . $currentmainnewsfile . ".html";
				my $linktext = '';
				if ($mainnewsleft == 1) {
					$linktext = $nextitemtext;
				} else {
					my $numnextitems = 0;

					if ($mainnewsleft >= $maxmainnews) {
						$numnextitems = $maxmainnews;
					} elsif ($mainnewsleft > 1) {
						$numnextitems = $mainnewsleft
					}
					$linktext = $nextitemstext;
					$linktext =~ s/\#\#X\#\#/$numnextitems/;
				}
				$linktext =~ s/\#\#nextnewsfile\#\#/$nextnewsfile/;

				print FULLNEWS $linktext;
				print FULLNEWS $mainnewsend;

				# start next main-news file
				close FULLNEWS;
				open FULLNEWS, ">$ppnews$nextnewsfile";
				open NEWSHDR, "<$pphtml" . "news.hdr";
				while (<NEWSHDR>) {
					print FULLNEWS;
				}
				close NEWSHDR;
				$mainnewswritten = 0;
				$lastdate{'none'} = '';
			}
		}
ISDELETED:	$counter--;
	} until ($counter < 0);
	WriteFooters();
	print FULLNEWS $mainnewsend;
	close FULLNEWS;
}

#Save this news in our database!
sub SaveMessage
{
	GetNewsData();

	(my $DateTime = localtime) =~ s/\://g;
	if (substr ($DateTime, 8, 1) =~ /\s+/) {
		substr ($DateTime, 8, 1) = '0';
	}

	my $WeekDay = substr $DateTime, 0, 3;
	# Format: WeekDay Month Day Time Year
	my @Date = split(/ /, $DateTime);
	my $key = $Date[4] . $NumMonth{$Date[1]} . $Date[2] . $Date[3];
	my $FileName = "$ppnews" . "$key";

	open MSG, ">$FileName" . ".msg";
	print MSG $NewsData{'text'};
	close MSG;

	open HEADLINE, ">$FileName" . ".hdl";
	print HEADLINE $NewsData{'headline'};
	close HEADLINE;

	# Now write central database file

	open DB, ">>$ppnews" . "news.db";
	my $SaveInMainNews = $cgi->param('saveinmainnews') || 0;
	print DB "$key $WeekDay $UserData{'userid'} $NewsData{'section'} $SaveInMainNews $NewsData{'article'}\n";
	close DB;

	Log("sent news to: $NewsData{'section'}.\n");
	OutputHTMLFile('newssent.html');
	WriteNewsFiles();
}


# Display a preview:

sub DisplayPreview
{
	GetNewsData();
	$NewsData{'text'} = InsertLinkToArticle($NewsData{'text'});
	if (($NewsData{'article'} !~ /^none$/) && (!$NewsData{'hasownlink'})) {
		$NewsData{'text'} .= $linktoarticle_preview;
	}

	print FileToScalar($pphtml . 'news.hdr');

	# Now fill the hashes: UserDate, DateTime

	my $ltime = localtime;
	if (substr ($ltime, 8, 1) =~ /\s+/) {
		substr ($ltime, 8, 1) = '0';
	}

	(my $weekday, my $monthstr, my $day, my $Time, my $year) = split (/ /, $ltime);
	my $month = $NumMonth{$monthstr};
	$DateTime{'date'} = "$day.$month.$year";
	$DateTime{'weekday'} = $FullWeekDay{ (substr $weekday, 0, 3)};
	$DateTime{'time'} = $Time;
	$DateTime{'day'} = $day;
	$DateTime{'month'} = $monthstr;
	$DateTime{'year'} = $year;
	$DateTime{'hour'} = substr $Time, 0, 2;     # 16:03:22
	$DateTime{'minute'} = substr $Time, 3, 2;
	$DateTime{'second'} = substr $Time, 6, 2;


	GetUserInfo($UserData{'userid'});

	open NEWSPRE, "<$pphtml" . "news.pre";
	while (<NEWSPRE>) {
		print SubstRefVars($_, 'pre');
	}
	close NEWSPRE;

	# Legacy code - we had no "news.end" prior to 1.02
	my $mainnewsend = "</body></html>";
	if (-e "$pphtml" . 'news.end') {
		$mainnewsend = '';
		open MAINNEWSEND, "$pphtml" . 'news.end';
		while (<MAINNEWSEND>) {
			$mainnewsend .= $_;
		}
		close MAINNEWSEND;
	}
	print $mainnewsend;

	Log("read preview.\n");
}

# Print all news-headlines by current author
sub PrintNewsTable
{
	open DB, "<$ppnews" . "news.db";
	my @AllNews = <DB>;
	close DB;

	OutputHTMLFile('newstbl.hdr');

	my $acclevel = $AccessLevel{$UserData{'userid'}};
	my $counter = $#AllNews;
	while ($counter >= 0) {
		(my $key, my $weekday, my $author, my $section, my $writeinmainnews, my $article ) = split (/ /, $AllNews[$counter]);
		if (($author =~ /$UserData{'userid'}/i) or ($acclevel & 2)) {

			if ($deleteforgood) {
				if (-e $ppnews . "$key.del") {
					$counter--; next;
				}
			}

			# Changed file:
			if (-e "$ppnews$key.fil") {
				open ARTICLE, "<$ppnews$key.fil";
				$article = <ARTICLE>;
				close ARTICLE;
			}
			chomp $article;
			$NewsData{'article'} = $article;

			if (-e "$ppnews$key.wmn") {
				open WMN, "<$ppnews$key.wmn";
				$writeinmainnews = <WMN>;
				close WMN;
			}

			if (-e "$ppnews$key.sec") {
				open SECTION, "<$ppnews$key.sec";
				$section = <SECTION>;
				close SECTION;
			}
			chomp $section;
			$NewsData{'section'} = $section;
			$NewsData{'key'} = $key;
			$NewsData{'year'} = substr $key, 0, 4;
			$NewsData{'month'} = substr $key, 4, 2;
			$NewsData{'day'} = substr $key, 6, 2;
			$NewsData{'headline'} = '';
			if (-e "$ppnews" . "$key.hdl") {
				open HEADLINE, "<$ppnews" . "$key.hdl";
				$NewsData{'headline'} = <HEADLINE>;
				close HEADLINE;
			}

			OutputHTMLFile('newstbl.pre');

			my $candelete = 0;
			if  ( $author =~ /$UserData{'userid'}/i ) {
				# Can he delete his own news?
				if ($acclevel & 1) {
					$candelete = 1;
				}
			} else {
				# Can he delete other's news?
				if ($acclevel & 4) {
					$candelete = 1;
				}
			}

			if ($candelete == 1) {
				my $description = '';
				if (-e $ppnews . "$key.del") {
					OutputHTMLFile('restore.html');
				} else {
					OutputHTMLFile('delete.html');
				}
			}
			OutputHTMLFile('newstbl.cls');
		}
		$counter -= 1;
	}
	OutputHTMLFile('newstbl.end');
}

sub EditNews
{
	my $key = $cgi->param('key');
	$key = filterUserInput($key);
	$NewsData{'key'} = $key;
	open HEADLINE, "<$ppnews" . "$key.hdl";
	$NewsData{'headline'} = <HEADLINE>;
	close HEADLINE;
	$NewsData{'article'} = $cgi->param('article');
	$NewsData{'section'} = $cgi->param('section');
	$NewsData{'text'} = FileToScalar("$ppnews$key.msg");
	OutputHTMLFile('editnews.html');
}

sub ResubmitNews
{
	GetNewsData();
	my $key = $cgi->param('key');
	$key = filterUserInput($key);
	my $oldarticle = $cgi->param('oldarticle') || 'none';
	my $oldsection = $cgi->param('oldsection');
	my $oldwriteinmainnews = $cgi->param('oldwriteinmainnews') || 0;
	my $writeinmainnews = $cgi->param('writeinmainnews') || 0;

	if ($NewsData{'article'} ne $oldarticle) {
		# Filename of article was changed, write FIL
		open ARTICLE, ">$ppnews$key.fil";
		print ARTICLE $NewsData{'article'};
		close ARTICLE;
	}

#	if (($section eq 'none') && ($writeinmainnews eq '0') && !IsBitSet($AccessLevel{$UserData{'userid'}}, 1)) {
		# Would equal to delete, but no access!
#	} else {
		if ($NewsData{'section'} ne $oldsection) {
			open SECTION, ">$ppnews$key.sec";
			print SECTION $NewsData{'section'};
			close SECTION;
		}

#		if ($writeinmainnews ne $oldwriteinmainnews) {
#			open WMN, ">$ppnews$key.wmn";
#			print WMN "$writeinmainnews";
#			close WMN;
#		}
#	}

	open MESSAGE, ">$ppnews" . "$key.msg";
	print MESSAGE $NewsData{'text'};
	close MESSAGE;

	open HEADLINE, ">$ppnews" . "$key.hdl";
	print HEADLINE $NewsData{'headline'};
	close HEADLINE;

	OutputHTMLFile('newsresent.html');
	WriteNewsFiles();

}

sub UploadFile()
{
	# Make the first section selected
	$NewsData{'section'} = $TheSections[0];
	OutputHTMLFile('uploadfile.html');
}

sub DoUpload()
{
	(my $file = $cgi->param('article')) =~ s/\\/\//g;
	(my $filename = $file) =~ s/.*\/(.*)/$1/;
	$filename = filterUserInput($filename);

	my $section = $cgi->param('section');
	$section = filterUserInput($section);
	my $user = $UserData{'userid'};
	my $owner = $user;
	my $buffer;
	my $bytesread = 0;

	if (-e "$sectionbase$section/$filename.fud") {
		open OWNER, "<$sectionbase$section/$filename.fud";
		$owner = <OWNER>;
		close OWNER;
	}

	if ($owner eq $user) {
		$file = $cgi->param('article');
		open COPY, ">$sectionbase$section/$filename";
		while ($bytesread=read($file, $buffer, 1024)) {
			print COPY $buffer;
		}
		close COPY;
		open OWNER, ">$sectionbase$section/$filename.fud";
		print OWNER $user;
		close OWNER;
		Log("uploaded file: $file\n");
		OutputHTMLFile('fileupok.html');
	} else {
		OutputHTMLFile('fileuperr.html');
	}
}

# Change E-Mail/Syntax-file
sub ChangeUserData
{
#	print "Changing user data!\n";
	my $NewEml = $cgi->param('email');
	my $NewSyn = $cgi->param('syntax');
	my $CurrentUser = $UserData{'userid'};

	open EMAIL, ">$ppuser$CurrentUser/$CurrentUser.eml";
	print EMAIL $NewEml;
	close EMAIL;
	open SYNTAX, ">$ppuser$CurrentUser/$CurrentUser.syn";
	print SYNTAX $NewSyn;
	close SYNTAX;
	$UserData{'email'} = $NewEml;
	$UserData{'syntax'} = $NewSyn;
	Log("changed E-Mail/Syntax: $NewEml/$NewSyn.\n");

	WriteNewsFiles();
#	GetUserInfo($CurrentUser);
	OutputHTMLFile("usrdatachanged.html");
#	OutputHTMLFile("newsup.html");
}


# Execution-entrypoint


# Read config-file

if (-e "cginews.conf") {
	open CONFIG, "<cginews.conf";
	while (<CONFIG>) {
		if (/^\#/) { next; }
		chomp;
		(my $variable, my $value) = split (/=/, $_, 2);
		if ($variable =~ /admin/i) {
			$webadmin = $value;
		} elsif ($variable =~ /basedir/i) {
			$value =~ s/(.*)\s+$/$1/;
			$value =~ s/\r//;
			if ( substr($value, -1, 1) ne '/') { $value .= '/'; }
			$pphtml = $value . 'html/';
			$ppuser = $value . 'users/';
			$sectionbase = $value . 'sections/';
			$ppnews = $value . 'news/';
		} elsif ($variable =~ /dateseparator/i) {
			$dateseparator = $value;
		} elsif ($variable =~ /deleteforgood/i) {
			$deleteforgood = $value;
		} elsif ($variable =~ /fullsections/i) {
			$fullsections = $value;
		} elsif ($variable =~ /maxmainnews/i) {
			$maxmainnews = $value;
		} elsif ($variable =~ /(linkbefore)$|(linkbefore_main)/i) {
			# legacy option: "linkbefore" - now "linkbefore_main".
			$linkbefore_main = $value;
		} elsif ($variable =~ /linkbefore_preview/i) {
			$linkbefore_preview = $value;
		} elsif ($variable =~ /linkbefore_section/i) {
			$linkbefore_section = $value;
		} elsif ($variable =~ /(linkafter)$|(linkafter_main)/i) {
			# legacy option: "linkafter" - now "linkafter_main".
			$linkafter_main = $value;
		} elsif ($variable =~ /linkafter_preview/i) {
			$linkafter_preview = $value;
		} elsif ($variable =~ /linkafter_section/i) {
			$linkafter_section = $value;
		} elsif ($variable =~ /linktoarticle$|linktoarticle_main/i) {
			# legacy option: "linktoarticle" - now "linktoarticle_main"
			$linktoarticle_main = $value;
		} elsif ($variable =~ /linktoarticle_preview/i) {
			$linktoarticle_preview = $value;
		} elsif ($variable =~ /linktoarticle_section/i) {
			$linktoarticle_section = $value;
		} elsif ($variable =~ /nextitemstext/i) {
			$nextitemstext = $value;
		} elsif ($variable =~ /nextitemtext/i) {
			$nextitemtext = $value;
		} elsif ($variable =~ /sections/i) {
			$value =~ s/(.*)\s+$/$1/;
			@TheSections = sort (split  /\s+/, $value);
		} elsif ($variable =~ /sectiondates/i) {
			$sectiondates = $value;
		} elsif ($variable =~ /weekdays/i) {
			my @weekdays = split /\s+/, $value;
			my $counter = 0;
			foreach my $wd (@weekdays) {
				$FullWeekDay{$ShortWeekDays[$counter]} = $wd;
				$counter++;
			}
		}
	}
	close CONFIG;
}

$NewsData{'sectionbase'} = $sectionbase;

# Load access levels

if (-e $ppuser . "access.def") {
	open ACCESS, "<$ppuser" . "access.def";
	while (<ACCESS>) {
		if (/^#/) { next; }
		chomp;
		(my $user, my $level) = split (/ /, $_);
		$user =~ tr/A-Z/a-z/;
		$AccessLevel{$user} = $level;
	}
	close ACCESS;
}


# Check what has to be done!

print "Content-type: text/html\n\n";

($UserData{'userid'} = $cgi->param('userid') || '') =~ tr/A-Z/a-z/;
$UserData{'userid'} = filterUserInput($UserData{'userid'});
if ($UserData{'userid'} eq '') {
	$UserData{'userid'} = 'none';
}

if (!CheckPassword()) {
	OutputHTMLFile('loginfailed.html');
	exit;
}

my $Action = $cgi->param('action') || '';

if ( $Action =~ /^submitnews/i) {
	my $Subaction = $cgi->param('action1') || 'nopreview';
	if ($Subaction =~ /^preview/i) {
		DisplayPreview();
	} else {
		SaveMessage();
	}
} elsif ( $Action =~ /^login/i) {
	GetUserInfo($UserData{'userid'});
	# And now the stuff to send some news!
	OutputHTMLFile('newsup.html');
} elsif ( $Action =~ /^changepw/i) {
	ChangeUserPassword;
} elsif ( $Action =~ /^changeeml/i) {
	ChangeUserData;
} elsif ( $Action =~ /^changenews/i) {
	PrintNewsTable;
} elsif ( $Action =~ /^editnews/i) {
	my $subaction = $cgi->param('action1') || 'nothing';
	if ($subaction !~ 'nothing') {
		my $key = $cgi->param('key') || '';
		$key = filterUserInput($key);
		if (-e $ppnews . "$key.del") {
			unlink ($ppnews. "$key.del");
		} else {
			open DELETED, ">$ppnews" . "$key.del";
			print DELETED "Message deleted!\n";
			close DELETED;
			if ($deleteforgood) {
				unlink ($ppnews . "$key.msg");
				unlink ($ppnews . "$key.hdl");
				if (-e $ppnews . "$key.fil") {
					unlink ($ppnews . "$key.fil");
				}
				if (-e $ppnews . "$key.sec") {
					unlink ($ppnews . "$key.sec");
				}
			}
		}
		WriteNewsFiles();
		PrintNewsTable();
	} else {
		EditNews();
	}
} elsif ( $Action =~ /^resubmitnews/i) {
	my $subaction = $cgi->param('action1');
	if ($subaction) {
		if ($subaction =~ /preview/i) {
			DisplayPreview();
		}
	} else {
		ResubmitNews();
	}
} elsif ( $Action =~ /^uploadfile/i) {
	UploadFile();
} elsif ( $Action =~ /^doupload/i) {
	DoUpload();
} else {
	PrintError("Wrong value for ACTION: $Action");
}

